routes/web.php
<?php

use App\Specialty;
use App\Symptom;
use Illuminate\Support\Facades\Auth;
use Illuminate\Http\Request;
use App\Doctor;
use App\Disease;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

// Route::get('/',function(){
//     return view ('blank');
// });

Route::get('/', 'HomeController@index');
Route::get('/home', 'HomeController@dash')->name('home');
Auth::routes(['verify' => true]);


Route::get('/profile', 'ProfileController@show')->name('profile.show');
Route::get('/profile/{id}', 'ProfileController@find')->name('profile.find');
Route::post('/profile', 'ProfileController@promotion')->name('profile.promotion');
//Route::get('/profile', 'ProfileController@edit')->name('profile.edit');
Route::put('/profile', 'ProfileController@update')->name('profile.update');
Route::resource('doctor_work', 'DoctorWorkController');//->name('doctor_work');
Route::resource('doctor_certificates', 'DoctorCertificatesController');

Route::get('search', 'HomeController@view')->name('search');
// Route::post('search', 'HomeController@search')->name('search');

//nationalites route
Route::resource('nationalities', 'NationalityController');

//specialties route
Route::resource('specialties', 'SpecialtyController');
Route::get('specialties/{id}/changeState', 'SpecialtyController@changeState')->name('specialties.changeState');

//specialties route
Route::resource('symptoms', 'SymptomController');
Route::get('symptoms/{id}/changeState', 'SymptomController@changeState')->name('symptoms.changeState');

//specialties route
Route::resource('diseases', 'DiseaseController');
Route::get('diseases/{id}/changeState', 'DiseaseController@changeState')->name('diseases.changeState');

Route::resource('register', 'RegisterController');
Route::get('register_doctor', 'RegisterController@create_doctor')->name('register_doctor');
Route::post('store_doctor', 'RegisterController@store_doctor')->name('store_doctor');

Route::resource('doctor_specialties', 'DoctorSpecialtyController');


Route::resource('doctors', 'DoctorController');
Route::get('doctors/{id}/activate', 'DoctorController@activate')->name('doctors.activate');



Route::resource('chats', 'ChatController');
Route::get('secialaties/{id}', function ($id) {
    $spec =  Specialty::find($id);
    
    $symptoms = collect(new Symptom());
    
    foreach ($spec->diseases as $des) {
        $symptoms = $symptoms->merge($des->symptoms);
    }    
    $uniqueCollection = $symptoms->unique('id'); 
    return $uniqueCollection;
})->name('load-spec');

Route::post('search', function (Request $request) {
    $syms =  Symptom::where('id',[$request->symptomsSelect])->get();
    $diseases = collect(new Disease());

    foreach ($syms as $key1 => $sym) {
        foreach ($sym->diseases as $key2 => $dis) {
            if($dis->id == $request->pecialty_id){
                if(!$diseases->contains($dis)){
                    $diseases->prepend($dis);
                }
            }
        }
        
    }
    
    $spec =  Specialty::find($request->pecialty_id);
    
    $specialties = Specialty::all();

    // foreach ($spec->users as $key => $user) {
    //     $doctors = $user;
    // }

    // $symptoms  = Symptom::all()->pluck('common_name')->toArray();

    // $symptoms = implode(",",$symptoms);
  
    $data = [
        'doctors' => $spec->users,
        'specialties' => $specialties,
        'symptoms' => $syms ,
         'diseases' => $spec->diseases,
    ];

 //   dd()
    return view('search')->with( $data);
})->name('search');

app/Specialty.php
<?php

namespace App;
use Illuminate\Database\Eloquent\SoftDeletes; // <-- This is required

use Illuminate\Database\Eloquent\Model;

class Specialty extends Model
{
    use SoftDeletes; // <-
    protected $dates = ['deleted_at'];
    public function diseases()
    {
        return $this->hasMany('App\Disease');
    }

    public function users()
    {
        return $this->belongsToMany(User::class, 'doctor_specialties');
    }
}

app/Http/Controllers/SpecialtyController.php
<?php

namespace App\Http\Controllers;

use App\Disease;
use App\Specialty;
use Illuminate\Http\Request;

class SpecialtyController extends Controller
{
    /** HomeController.php
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware(['auth', 'verified']);
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $specialties = Specialty::all();

        $data = [
            'specialties' => $specialties
        ];

        return View('specialties.index')->with($data);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('specialties.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $rules = [
            'name_ar' => 'required|string|min:1|unique:specialties,name_ar|alpha',
            'name_en' => 'required|string|min:1|unique:specialties,name_en|alpha',
        ];

        $messages = [
        ];

        $this->validate($request, $rules,$messages);

        $specialty = new Specialty;
        $specialty->name_ar = $request->name_ar;
        $specialty->name_en = $request->name_en;
        $specialty->save();

        return redirect()->route('specialties.index')->with('success', 'تم إضافة التخصص إلى قاعدة البيانات بنجاح');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Specialty  $specialty
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $specialty =  Specialty::findOrFail($id);

        $diseases =  $specialty->diseases;
        $data = [
            'diseases' => $diseases
        ];
        return view('specialties.show')->with($data);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Specialty  $specialty
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $specialty = Specialty::find($id);
        return view('specialties.edit')->with(['specialty' => $specialty]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Specialty  $specialty
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $rules = [
            'name_ar' => 'required|string|min:1|unique:specialties,name_ar|alpha,' . $id,
            'name_en' => 'required|string|min:1|unique:specialties,name_en|alpha,' . $id,
        ];

        $messages = [
        ];

        $this->validate($request, $rules,$messages);

        $specialty = Specialty::findOrFail($id);

        $specialty->name_ar = $request->name_ar;
        $specialty->name_en = $request->name_en;
        $specialty->update();

        return redirect()->route('specialties.index')->with('success', 'تم تعديل التخصص في قاعدة البيانات بنجاح');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Specialty  $specialty
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //$specialty = 
        Specialty::find($id)->delete();
     //   $specialty->delete();

        return redirect()->route('specialties.index')->with('success','تمت عملية حذف التخصص من قاعدة البيانات بنجاح');
    }

    
    public function changeState($id)
    {
        $specialty = Specialty::findOrFail($id);
        $specialty->active = !$specialty->active;
        $specialty->update();
        
        $msg = '';
        if ($specialty->active == 1) {
            $msg = 'تمت عملية تفعيل التخصص في قاعدة البيانات بنجاح';
        } else {
            $msg = 'تمت عملية تعطيل التخصص في قاعدة البيانات بنجاح';
        }
        return redirect()->route('specialties.index')->with('success', $msg);
    }

}

resources/views/specialties/create.blade.php
@extends('layouts.main')

@section('content')
    <div class="container-fluid mt--7">
        <div class="row">
            <div class="col">
                <div class="card shadow">
                    <div>
                    {{-- @include('includes.messages') --}}
                    <p class="main-title">إدارة التخصصات | </p>
                    <p class="smale-title">إضافة تخصص</p>
                </div>
                <div class="bord">
                    <form method="POST" action="{{ route('specialties.store') }}">
                        @csrf
                        <div class="row">
                            <div class="col-lg-12">
                                <label class="form-control-label " >الاسم بالعربية</label>
                                    <div class="form-group focused {{ $errors->has('name_ar') ? ' has-danger' : '' }}">
                                    <input type="text" name="name_ar" value="{{ old('name_ar') }}" class="form-control {{ $errors->has('name_ar') ? ' is-invalid' : '' }} " placeholder="الاسم بالعربية">
                                    @if ($errors->has('name_ar'))
                                        <span class="is-invalid" role="alert">
                                            <strong>{{ $errors->first('name_ar') }}</strong>
                                        </span>
                                    @endif  
                                </div>
                            </div>
                        </div>

                        <div class="row">
                            <div class="col-lg-12">
                                <label class="form-control-label " >الاسم بالانجليزية</label>
                                    <div class="form-group focused {{ $errors->has('name_en') ? ' has-danger' : '' }}">
                                    <input type="text" name="name_en" value="{{ old('name_en') }}"  class="form-control {{ $errors->has('name_en') ? ' is-invalid' : '' }}" placeholder="الاسم بالانجليزية">
                                    @if ($errors->has('name_en'))
                                        <span class="is-invalid" role="alert">
                                            <strong>{{ $errors->first('name_en') }}</strong>
                                        </span>
                                    @endif  
                                </div>
                            </div>
                        </div>

                        <div class="row">
                            <div class=" col-md-12 ">
                                <button type="submit" class="btn btn-success">
                                    حفظ <i class="fa fa-check"></i>
                                </button>
                                <a href="{{route('specialties.index')}}" class="btn btn-danger">   إلغاء الأمر <i class="fa fa-close"></i> </a>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/specialties/edit.blade.php
@extends('layouts.main')

@section('content')
    <div class="container-fluid mt--7">
        <div class="row">
            <div class="col">
                <div class="card shadow">
                    <div>
                    @include('includes.messages')
                    <p class="main-title">إدارة التخصصات | </p>
                    <p class="smale-title">إضافة تخصص</p>
                </div>
                <div class="bord">
                    <form method="POST" action="{{ route('specialties.update', $specialty->id) }}">
                        @csrf
                        @method('PUT')
                        <div class="row">
                            <div class="col-lg-12">
                                <div class="form-group focused">
                                    <label class="form-control-label " >التخصص بالعربية</label>
                                    <input type="text" name="name_ar" value="{{ $specialty->name_ar }}" class="form-control form-control-alternative" placeholder="التخصص بالعربية">
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-lg-12">
                                <div class="form-group focused">
                                    <label class="form-control-label " >التخصص بالانجليزية</label>
                                    <input type="text" name="name_en" value="{{ $specialty->name_en }}" class="form-control form-control-alternative" placeholder="التخصص بالانجليزية">
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class=" col-md-12 ">
                                <button type="submit" class="btn btn-success">
                                    حفظ <i class="fa fa-check"></i>
                                </button>
                                <a href="{{route('specialties.index')}}" class="btn btn-danger">   إلغاء الأمر <i class="fa fa-close"></i> </a>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/specialties/index.blade.php
@extends('layouts.main')

@section('content')
    <div class="container-fluid mt--7">
      <div class="row">
        
        <div class="col">
          <div class="card shadow">
              @include('includes.messages')
            
                <div>
                    <p class="main-title">إدارة التخصصات | </p>
                    <p class="smale-title">قائمة التخصصات</p>
                </div>
            <div class="row">
              <div>
                <a class="btn btn-success" href="{{ route('specialties.create') }}"> إضافة</span></a>
              </div>
            </div>
            <br>
            <div class="table-responsive">
              <table class="table align-items-center table-flush">
                <thead class="thead-light">
                  <tr>
                    <th>#رقم</th>
                    <th width="30%">التخصص بالعربية</th>
                    <th width="30%">التخصص بالانجليزية</th>
                    <th width="20%">الحالة</th>
                    <th>العمليات</th>
                  </tr>
                </thead>
                <tbody style="text-align: center">
                  @foreach ($specialties as $index => $specialty)
                    <tr>
                      <td> {{ $index + 1 }} </td>
                      <td> {{ $specialty->name_ar }} </td>
                      <td> {{ $specialty->name_en }} </td>

                      <td>
                          @if ($specialty->active == 1)
                              <div class="badge badge-success">مفعل</div>
                          @else
                              <div class="badge badge-danger">معطل</div>
                          @endif
                      </td>

                      <td>
                        <a class="btn btn-info  btn-sm" href="{{ route('specialties.show', $specialty->id)}}"><span class="fa fa-eye"></span>عرض </a>
                        @if ($specialty->active == 1)
                            <a href="{{route('specialties.changeState', $specialty->id)}}" class="btn btn-danger btn-sm"><span class="fa fa-close"></span>تعطيل</a>
                        @else
                            <a href="{{route('specialties.changeState', $specialty->id)}}" class="btn btn-success btn-sm"><span class="fa fa-check"></span>ـفعيل</a>
                        @endif
                        <a class="btn btn-primary  btn-sm" href="{{ route('specialties.edit', $specialty->id)}}"><span class="fa fa-edit"></span>تعديل</a>
                        {{--  <a class="btn btn-danger remove-record btn-sm" data-csrf="{{csrf_token()}}" data-toggle="modal" data-url="{{route('specialties.destroy', $specialty->id) }}" data-id="{{$specialty->id}}" data-target="#custom-width-modal"><span class="fa fa-trash"></span>حذف</a>  --}}

                      </td>
                    </tr>  
                  @endforeach

                </tbody>
              </table>
            </div>
          </div>
        </div>
      </div>
    </div>
</div>
@endsection

@section('modals')
    @include('includes.delete-confirmation')
@endsection

@section('scripts')
    {{-- <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script> --}}
    <script src="{{ asset('js/delete-confremation.js') }}"></script>
@endsection

resources/views/specialties/show.blade.php
@extends('layouts.main')
@section('styles')
    {{-- <link rel="stylesheet" href="{{asset('css/jquery.dataTables.min.css')}}"> --}}
@endsection
@section('content')

    <div class="container-fluid mt--7">
      <div class="row">
        
        <div class="col">
          <div class="card shadow">
                <div>
                    <p class="main-title">أمراض هذا التخصص</p>
                </div>

            <br>
            <div class="table-responsive">
              <table  id="myTable" class="table align-items-center table-flush">
                <thead class="thead-light">
                  <tr>
                    <th>#رقم</th>
                    <th width="30%">الاسم العلمي</th>
                    <th width="30%">الاسم الشائع</th>
                    <th width="30%">التخصص</th>
                    <th width="20%">الحالة</th>
                  </tr>
                </thead>
                <tbody style="text-align: center">
                  @foreach ($diseases as $index => $disease)
                    <tr>
                      <td> {{ $index + 1 }} </td>
                      <td> {{ $disease->name }} </td>
                      <td> {{ $disease->common_name }} </td>
                      <td> 
                        <div class="badge badge-pill badge-success"> AR  </div>
                        {{ $disease->specialty->name_ar }}
                        <br>
                        <div class="badge badge-pill badge-success"> EN  </div>
                        {{ $disease->specialty->name_en }}
                      
                      </td>

                      <td>
                          @if ($disease->active == 1)
                              <div class="badge badge-success">مفعل</div>
                          @else
                              <div class="badge badge-danger">معطل</div>
                          @endif
                      </td>
                    </tr>  
                  @endforeach

                </tbody>
              </table>
            </div>
            @if ($diseases->isEmpty())
                <br>
                <div style="text-align: center; color: #f5365c;">لا توجد أمراض لهذا التخصص</div>
                <br>
            @endif
          </div>
        </div>
        </div>
        <br>
        <div class="row">
            <div class=" col-md-12 ">
                <a href="{{route('specialties.index')}}" class="btn btn-danger">   رجوع <i class="fa fa-close"></i> </a>
            </div>
        </div>
    </div>
</div>
@endsection

@section('modals')
    @include('includes.delete-confirmation')
@endsection

@section('scripts')
    {{-- <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script> --}}
    <script src="{{ asset('js/delete-confremation.js') }}"></script>
    {{-- <script src="{{asset('js/dataTables.bootstrap.min.js')}}"></script> --}}
    {{-- <script src="{{asset('js/jquery.dataTables.min.js')}}"></script> --}}

    {{-- <script>
      $(document).ready( function () {
          $('#myTable').DataTable();
      });
    </script> --}}

@endsection